# MorphoBlueReallocateLiquidity

### Description

Action that bundles calls to Morpho Blue Public Allocator to reallocate liquidity for additional borrowing

### Action ID

`0x75852bc7`

### SDK Action

```ts
const morphoBlueReallocateLiquidityAction = new dfs.actions.morpho-blue.MorphoBlueReallocateLiquidityAction(
    loanToken,
    collateralToken,
    oracle,
    irm,
    lltv,
    vaults,
    withdrawals
);
```

### Action Type

`STANDARD_ACTION`

### Input Parameters

```solidity
    /// @param marketParams Market params for the Morpho Blue market where liquidity will be reallocated to.
    /// @param vaults List of vaults used for reallocation.
    /// @param withdrawals List of withdrawals for each vault.
    struct Params {
        MarketParams marketParams;
        address[] vaults;
        Withdrawal[][] withdrawals;
    }
```

### Return Value

```solidity
return bytes32(0);
```

### Events and Logs

```solidity
emit ActionEvent("MorphoBlueReallocateLiquidity", logData);
logger.logActionDirectEvent("MorphoBlueReallocateLiquidity", logData);
bytes memory logData = abi.encode(params);
```


---

# Agent Instructions: Querying This Documentation

If you need additional information that is not directly available in this page, you can query the documentation dynamically by asking a question.

Perform an HTTP GET request on the current page URL with the `ask` query parameter:

```
GET https://docs.defisaver.com/actions/morphoblue/morphobluereallocateliquidity.md?ask=<question>
```

The question should be specific, self-contained, and written in natural language.
The response will contain a direct answer to the question and relevant excerpts and sources from the documentation.

Use this mechanism when the answer is not explicitly present in the current page, you need clarification or additional context, or you want to retrieve related documentation sections.
